'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _geocoderArcgisGeojson = require('@conveyal/geocoder-arcgis-geojson');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactSelectGeocoder = require('react-select-geocoder');

var _reactSelectGeocoder2 = _interopRequireDefault(_reactSelectGeocoder);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Geocoder = function (_Component) {
  (0, _inherits3.default)(Geocoder, _Component);

  function Geocoder() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, Geocoder);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = Geocoder.__proto__ || (0, _getPrototypeOf2.default)(Geocoder)).call.apply(_ref, [this].concat(args))), _this), _this._onChange = function (value) {
      var _this$props = _this.props,
          clientId = _this$props.clientId,
          clientSecret = _this$props.clientSecret,
          forStorage = _this$props.forStorage,
          onChange = _this$props.onChange;

      // check to see if value is a geolocate result or autocomplete value

      if (value.feature) {
        onChange && onChange(value.feature);
      } else {
        // result is autocomplete result without address or coordinate data
        // do geocode to get info
        (0, _geocoderArcgisGeojson.search)({
          clientId: clientId,
          clientSecret: clientSecret,
          magicKey: value.magicKey,
          forStorage: forStorage,
          text: value.text
        }).then(function (result) {
          onChange && onChange(result.features[0]);
        }).catch(function (err) {
          // not quite sure what to do with error here
          console.error(err);
        });
      }
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(Geocoder, [{
    key: '_getReverseSearch',
    value: function _getReverseSearch() {
      if (this.props.reverseSearch) {
        return this.props.reverseSearch;
      } else {
        var _props = this.props,
            _clientId = _props.clientId,
            _clientSecret = _props.clientSecret,
            _forStorage = _props.forStorage;

        return function (query) {
          query.clientId = _clientId;
          query.clientSecret = _clientSecret;
          query.forStorage = _forStorage;
          return (0, _geocoderArcgisGeojson.reverse)(query);
        };
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(_reactSelectGeocoder2.default, (0, _extends3.default)({}, this.props, {
        apiKey: 'dummy' // include because it's a required propType in react-select-geocoder
        , onChange: this._onChange,
        reverseSearch: this._getReverseSearch()
      }));
    }
  }]);
  return Geocoder;
}(_react.Component);

Geocoder.defaultProps = {
  featureToLabel: function featureToLabel(feature) {
    // feature can be either an autocomplete result or a reverse result
    // return the proper label based on what the object looks like
    return feature.magicKey ? feature.text : feature.properties.label;
  },
  featureToValue: function featureToValue(feature) {
    return feature.text + '-' + feature.magicKey;
  },
  search: _geocoderArcgisGeojson.autocomplete
};
exports.default = Geocoder;
module.exports = exports['default'];

//# sourceMappingURL=index.js